package grammar;

import type2.Type2GrammarGenerator;

public class Type2Grammar extends Grammar {

	Type2GrammarGenerator g = new Type2GrammarGenerator();

	public Type2Grammar(String[] vars, int alphaSize, String start, int maxConclusios, int maxConclusioSize, int mode) {
		super(vars, alphaSize, start);
		switch (mode) {
		case 0:
			this.setRules(g.genType2GrammarRuleSet0(vars, alphaSize, maxConclusios, maxConclusioSize));
			break;
		case 1:
			this.setRules(g.genType2GrammarRuleSet1(vars, alphaSize, maxConclusios, maxConclusioSize, start));
			break;
		case 2:
			this.setRules(g.genType2GrammarRuleSet2(vars, alphaSize, maxConclusios, maxConclusioSize));
			break;
		case 3:
			this.setRules(g.genType2GrammarRuleSet3(vars, alphaSize, maxConclusios, maxConclusioSize, start));
			break;
		default:
			break;
		}

	}

	public static void main(String[] args) {
		String[] vars = { "S", "A", "B" };
		int alphaSize = 2;
		String start = "S";
		int maxConclusios = 2;
		int maxConclusioSize = 3;
		int mode = 3;
		Grammar gr = new Type2Grammar(vars, alphaSize, start, maxConclusios, maxConclusioSize, mode);
		System.out.println(gr);
	}

}
